VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AM_P"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ARCADEmini plugin for BPE
' version 0.9.1 date 2005-06-21
' Copyright (C) 2004-2005 Stefan Schuermans <1stein@schuermans.info>
' Copyleft: GNU public license - see COPYING.txt - http://www.gnu.org/copyleft/gpl.html
Const WinApiGenericRead = &H80000000
Const WinApiGenericWrite = &H40000000
Const WinApiOpenExisting = &H3
Const WinApiSeekEnd = &H2
Private Declare Function WinApiCreateFile Lib "kernel32" Alias "CreateFileA" _
  (ByVal lpFileName As String, _
  ByVal dwDesiredAccess As Long, _
  ByVal dwShareMode As Long, _
  ByVal SecurityAttributes As Long, _
  ByVal dwCreationDisposition As Long, _
  ByVal dwFlagsAndAttributes As Long, _
  ByVal hTemplateFile As Long) As Long
Private Declare Function WinApiCloseHandle Lib "kernel32" Alias "CloseHandle" _
  (ByVal hObject As Long) As Long
Private Declare Function WinApiReadFile Lib "kernel32" Alias "ReadFile" _
  (ByVal hFile As Long, _
  ByRef Buffer As Any, _
  ByVal BufferSize As Long, _
  ByRef BytesRead As Long, _
  ByVal Overlapped As Long) As Long
Private Declare Function WinApiWriteFile Lib "kernel32" Alias "WriteFile" _
  (ByVal hFile As Long, _
  ByRef Buffer As Any, _
  ByVal BufferSize As Long, _
  ByRef BytesWritten As Long, _
  ByVal Overlapped As Long) As Long
Private Declare Function WinApiWriteFileStr Lib "kernel32" Alias "WriteFile" _
  (ByVal hFile As Long, _
  ByVal Buffer As String, _
  ByVal BufferSize As Long, _
  ByRef BytesWritten As Long, _
  ByVal Overlapped As Long) As Long
Private Declare Function WinApiDeviceIoControl Lib "kernel32" Alias "DeviceIoControl" _
  (ByVal hDevice As Long, _
  ByVal dwIoControlCode As Long, _
  ByRef lpInBuffer As Any, _
  ByVal nInBufferSize As Long, _
  ByRef lpOutBuffer As Any, _
  ByVal nOutBufferSize As Long, _
  ByRef lpBytesReturned As Long, _
  ByVal Overlapped As Long) As Long
Private Declare Function WinApiSetFilePointer Lib "kernel32" Alias "SetFilePointer" _
  (ByVal hFile As Long, _
  ByVal lDistanceToMove As Long, _
  ByVal lpDistanceToMoveHigh As Long, _
  ByVal dwMoveMethod As Long) As Long

Private Type tFrame
  Pixels(259) As Byte
End Type

Private CallingApp As String
Private mFilename As String

Private AmUsbNo As Long
Private hAmUsb As Long
Private hAmUsbLog As Long

Private Sub LogLine(Txt As String)
  ' schreibe bergebene Zeile mit Datum und Zeit in die Log-Datei
  Dim T As String
  Dim I As Long
  If hAmUsbLog = -1 Then Exit Sub
  T = Format$(Date, "yyyy-mm-dd") + " " _
    + Format(Time, "hh:mm:ss") + ": " _
    + Txt _
    + Chr$(13) + Chr$(10)
  WinApiWriteFileStr hAmUsbLog, T, Len(T), I, 0
End Sub

Private Function GetPixel(OutputData() As Byte, ByVal MaxVal As Byte, ByVal SizeX As Long, ByVal SizeY As Long, ByVal X As Long, ByVal Y As Long) As Byte
  ' hole einen Pixel aus dem Datenfeld
  ' - liefere 0 zurck, wenn Pixel ausserhalb der zulssgen Koordinaten
  ' - passe Graustufe auf 16 Graustufen-Display an
  If X >= 0 And X < SizeX And Y >= 0 And Y < SizeY Then
    GetPixel = OutputData(X + 1, Y + 1) * &HF \ MaxVal
  Else
    GetPixel = 0
  End If
End Function

Public Function PluginName() As String
  'Liefert den Pluginnamen zurck, den der BPE anzeigt
  PluginName = "ARCADEmini (by 1stein)"
End Function

Public Function GetDisplayWidth() As Long
  'Liefert die Breite des Displays zurck
  GetDisplayWidth = 26
End Function

Public Function GetDisplayHeight() As Long
  'Liefert die Hhe des Displays zurck
  GetDisplayHeight = 20
End Function

Public Function OutputToDevice(OutputData() As Byte, ColorDepth As Byte, SizeX As Long, SizeY As Long) As Boolean
  ' Wird jedes mal aufgerufen, wenn ein neuer Frame ausgegeben werden soll
  ' OutputData: Byte-Array, das die einzelnen Pixel-Werte enthlt. Auslesen z.B per OutputData(X, Y)
  ' ColorDepth: Enthlt die Anzahl der Bits fr die Farbtiefe
  ' SizeX: Anzahl der Pixel in OutputData fr die Breite
  ' SizeY: Anzahl der Pixel in OutputData fr die Hhe
  Dim Frame As tFrame
  Dim MaxVal, OfsX, OfsY, I, X, Y, BytesReturned As Long
  If hAmUsb <> -1 Then
    ' Anzahl Graustufen und Verschiebung berechnen
    MaxVal = 2 ^ ColorDepth - 1
    OfsX = (SizeX - 26) \ 2
    OfsY = (SizeY - 20) \ 2
    ' 260 Bytes fr ARCADEmini mit Pixeldaten fllen
    For I = 0 To 259
      X = (I Mod 13) * 2
      Y = I \ 13
      Frame.Pixels(I) = (GetPixel(OutputData, MaxVal, SizeX, SizeY, X + OfsX, Y + OfsY) And &HF) * &H10 _
                      + (GetPixel(OutputData, MaxVal, SizeX, SizeY, X + OfsX + 1, Y + OfsY) And &HF)
    Next I
    ' Daten zu ARCADEmini
    If WinApiDeviceIoControl(hAmUsb, &H220040, Frame, 260, Null, 0, BytesReturned, 0) <> 0 And _
       WinApiDeviceIoControl(hAmUsb, &H220080, Null, 0, Null, 0, BytesReturned, 0) <> 0 Then _
      LogLine "wrote Frame (" + Trim$(Str$(SizeX)) + "x" + Trim$(Str$(SizeY)) + "/" + Trim$(Str$(ColorDepth)) + ") to ARCADEmini"
    Else
      LogLine "could not write Frame (" + Trim$(Str$(SizeX)) + "x" + Trim$(Str$(SizeY)) + "/" + Trim$(Str$(ColorDepth)) + ") to ARCADEmini"
  End If
  OutputToDevice = True
End Function

Public Function Configure() As Boolean
  'Diese Funktion wird aufgerufen, wenn der Benutzer die Plugineinstellungen ndern mchte.
  Dim Msg As String
  Msg = "ARCADEmini plugin for BPE" + Chr$(13) + Chr$(10) _
      + "version 0.9.1 date 2005-06-21" + Chr$(13) + Chr$(10) _
      + "Copyright (C) 2004-2005 Stefan Schuermans <1stein@schuermans.info>" + Chr$(13) + Chr$(10) _
      + "Copyleft: GNU public license - see COPYING.txt - http://www.gnu.org/copyleft/gpl.html" + Chr$(13) + Chr$(10) _
      + "" + Chr$(13) + Chr$(10) _
      + "Nummer des zu ffnenden ARCADEmini (0-15):"
  AmUsbNo = Val(Left$(InputBox(Msg, , AmUsbNo), 5))
  If AmUsbNo < 0 Then AmUsbNo = 0
  If AmUsbNo > 15 Then AmUsbNo = 15
  Configure = True
End Function

Public Function Init(CallingAppTitle As String, MyFilename As String) As Boolean
  'Wird beim Start des Plugins ausgefhrt.
  Dim AmUsbName As String
  CallingApp = CallingAppTitle
  mFilename = MyFilename
  'Einstellungen laden
  AmUsbNo = Val(Left$(GetSetting(CallingApp, "Plugins\" & mFilename, "AmUsbNo", "0"), 5))
  'Logdatei ffnen, falls sie bereits existiert (und zum Ende gehen)
  hAmUsbLog = WinApiCreateFile("BPE-AmUsb.log", WinApiGenericRead Or WinApiGenericWrite, 0, 0, WinApiOpenExisting, 0, 0)
  If hAmUsbLog <> -1 Then WinApiSetFilePointer hAmUsbLog, 0, 0, WinApiSeekEnd
  LogLine "ARCADEmini plugin for BPE"
  LogLine "version 0.9.1 date 2005-06-21"
  LogLine "Copyright (C) 2004-2005 Stefan Schuermans <1stein@schuermans.info>"
  LogLine "Copyleft: GNU public license - see COPYING.txt - http://www.gnu.org/copyleft/gpl.html"
  'ARCADEmini ffnen
  AmUsbName = "\\.\AmUsb" + Trim$(Str$(AmUsbNo))
  hAmUsb = WinApiCreateFile(AmUsbName, WinApiGenericRead Or WinApiGenericWrite, 0, 0, WinApiOpenExisting, 0, 0)
  If hAmUsb = -1 Then LogLine "could not open " + AmUsbName _
                 Else LogLine "opened " + AmUsbName
  Init = True
End Function

Public Function Term() As Boolean
  'Wird beim Beenden des Plugins ausgefhrt
  'ARCADEmini schlieen
  If hAmUsb <> -1 Then
    WinApiCloseHandle hAmUsb
    LogLine "closed \\.\AmUsb0"
  End If
  'Logdatei schlieen
  If hAmUsbLog <> -1 Then WinApiCloseHandle hAmUsbLog
  'Einstellung speichern
  SaveSetting CallingApp, "Plugins\" & mFilename, "AmUsbNo", Trim$(Str$(AmUsbNo))
  Term = True
End Function
